ghc-8.2.2: The GHC API

Safe Haskell | None
Language | Haskell2010

SetLevels

# Documentation

setLevels :: FloatOutSwitches -> CoreProgram -> UniqSupply -> [LevelledBind] #

data Level #

Constructors

Level Int Int LevelType |

Instances

Eq Level # |
Methods (==) :: Level -> Level -> Bool # (/=) :: Level -> Level -> Bool #
Outputable Level # |
Methods ppr :: Level -> SDoc # pprPrec :: Rational -> Level -> SDoc #

data LevelType #

Constructors

BndrLvl |
JoinCeilLvl |

Instances

Eq LevelType # |
Methods (==) :: LevelType -> LevelType -> Bool # (/=) :: LevelType -> LevelType -> Bool #

tOP_LEVEL :: Level #

isJoinCeilLvl :: Level -> Bool #

asJoinCeilLvl :: Level -> Level #

type LevelledBind = TaggedBind FloatSpec #

type LevelledExpr = TaggedExpr FloatSpec #

type LevelledBndr = TaggedBndr FloatSpec #

data FloatSpec #

Constructors

FloatMe Level |
StayPut Level |

Instances

Outputable FloatSpec # |
Methods ppr :: FloatSpec -> SDoc # pprPrec :: Rational -> FloatSpec -> SDoc #

floatSpecLevel :: FloatSpec -> Level #

incMinorLvl :: Level -> Level #

ltMajLvl :: Level -> Level -> Bool #

ltLvl :: Level -> Level -> Bool #

isTopLvl :: Level -> Bool #